# openapi-client
Platform REST API OpenAPI specification (OAS). 
See the Interactive Docs to try ChatKitty API methods without writing code, 
and get the complete schema of resources exposed by the API.

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: v1.15.10
- Package version: 1.0.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen
For more information, please visit [mailto:support@chatkitty.com](mailto:support@chatkitty.com)

## Requirements.

Python >=3.6

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import openapi_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import openapi_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import time
import openapi_client
from pprint import pprint
from openapi_client.api import application_api
from openapi_client.model.api_error import ApiError
from openapi_client.model.application_resource import ApplicationResource
from openapi_client.model.application_settings_properties import ApplicationSettingsProperties
from openapi_client.model.application_settings_resource import ApplicationSettingsResource
from openapi_client.model.authentication_error import AuthenticationError
# Defining the host is optional and defaults to https://api.chatkitty.com
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "https://api.chatkitty.com"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure OAuth2 access token for authorization: application_authorization
configuration = openapi_client.Configuration(
    host = "https://api.chatkitty.com"
)
configuration.access_token = 'YOUR_ACCESS_TOKEN'


# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = application_api.ApplicationApi(api_client)

    try:
        # Retrieve the authenticated application
        api_response = api_instance.retrieve_authenticated_application()
        pprint(api_response)
    except openapi_client.ApiException as e:
        print("Exception when calling ApplicationApi->retrieve_authenticated_application: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://api.chatkitty.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ApplicationApi* | [**retrieve_authenticated_application**](docs/ApplicationApi.md#retrieve_authenticated_application) | **GET** /v1/application | Retrieve the authenticated application
*ApplicationApi* | [**retrieve_authenticated_application_settings**](docs/ApplicationApi.md#retrieve_authenticated_application_settings) | **GET** /v1/application/settings | Retrieve the authenticated application settings
*ApplicationApi* | [**update_authenticated_application_settings**](docs/ApplicationApi.md#update_authenticated_application_settings) | **PUT** /v1/application/settings | Update the authenticated application settings
*ChannelsApi* | [**add_channel_member**](docs/ChannelsApi.md#add_channel_member) | **POST** /v1/channels/{id}/members | Add a channel member
*ChannelsApi* | [**add_channel_moderator**](docs/ChannelsApi.md#add_channel_moderator) | **POST** /v1/channels/{id}/moderators | Add a channel moderator
*ChannelsApi* | [**create_channel**](docs/ChannelsApi.md#create_channel) | **POST** /v1/channels | Create a channel
*ChannelsApi* | [**delete_channel**](docs/ChannelsApi.md#delete_channel) | **DELETE** /v1/channels/{id} | Delete a channel
*ChannelsApi* | [**remove_channel_member**](docs/ChannelsApi.md#remove_channel_member) | **DELETE** /v1/channels/{id}/members/{user_id} | Remove a channel member
*ChannelsApi* | [**retrieve_channel**](docs/ChannelsApi.md#retrieve_channel) | **GET** /v1/channels/{id} | Retrieve a channel
*ChannelsApi* | [**retrieve_channel_invites**](docs/ChannelsApi.md#retrieve_channel_invites) | **GET** /v1/channels/{id}/invites | Retrieve channel invites
*ChannelsApi* | [**retrieve_channel_members**](docs/ChannelsApi.md#retrieve_channel_members) | **GET** /v1/channels/{id}/members | Retrieve a channel&#39;s members
*ChannelsApi* | [**retrieve_channel_memberships**](docs/ChannelsApi.md#retrieve_channel_memberships) | **GET** /v1/channels/{id}/memberships | Retrieve channel memberships
*ChannelsApi* | [**retrieve_channel_messages**](docs/ChannelsApi.md#retrieve_channel_messages) | **GET** /v1/channels/{id}/messages | Retrieve channel messages
*ChannelsApi* | [**retrieve_channel_participants**](docs/ChannelsApi.md#retrieve_channel_participants) | **GET** /v1/channels/{id}/participants | Retrieve channel participants
*ChannelsApi* | [**retrieve_channels**](docs/ChannelsApi.md#retrieve_channels) | **GET** /v1/channels | Retrieve channels
*ChannelsApi* | [**send_channel_event**](docs/ChannelsApi.md#send_channel_event) | **POST** /v1/channels/{id}/events | Send a channel event
*ChannelsApi* | [**send_channel_invite**](docs/ChannelsApi.md#send_channel_invite) | **POST** /v1/channels/{id}/invites | Send a channel invite
*ChannelsApi* | [**send_channel_message**](docs/ChannelsApi.md#send_channel_message) | **POST** /v1/channels/{id}/messages | Send a channel message
*ChannelsApi* | [**update_channel**](docs/ChannelsApi.md#update_channel) | **PATCH** /v1/channels/{id} | Update a channel
*FunctionVersionsApi* | [**retrieve_function_version**](docs/FunctionVersionsApi.md#retrieve_function_version) | **GET** /v1/function-versions/{id} | Retrieve a chat function version
*FunctionsApi* | [**create_function_version**](docs/FunctionsApi.md#create_function_version) | **POST** /v1/functions/{id}/versions | Create a chat function version
*FunctionsApi* | [**retrieve_function**](docs/FunctionsApi.md#retrieve_function) | **GET** /v1/functions/{id} | Retrieve a chat function
*FunctionsApi* | [**retrieve_function_current_version**](docs/FunctionsApi.md#retrieve_function_current_version) | **GET** /v1/functions/{id}/current-version | Retrieve chat function current version
*FunctionsApi* | [**retrieve_function_invocations**](docs/FunctionsApi.md#retrieve_function_invocations) | **GET** /v1/functions/{id}/invocations | Retrieve chat function invocations
*FunctionsApi* | [**retrieve_function_versions**](docs/FunctionsApi.md#retrieve_function_versions) | **GET** /v1/functions/{id}/versions | Retrieve chat function versions
*ImportsApi* | [**import_channel_members**](docs/ImportsApi.md#import_channel_members) | **POST** /v1/imports/channels/{id}/members | Import channel members
*ImportsApi* | [**import_channels**](docs/ImportsApi.md#import_channels) | **POST** /v1/imports/channels | Import channels
*ImportsApi* | [**import_messages**](docs/ImportsApi.md#import_messages) | **POST** /v1/imports/messages | Import messages
*ImportsApi* | [**import_users**](docs/ImportsApi.md#import_users) | **POST** /v1/imports/users | Import users
*JobsApi* | [**retrieve_job**](docs/JobsApi.md#retrieve_job) | **GET** /v1/jobs/{id} | Retrieve a job
*JobsApi* | [**retrieve_jobs**](docs/JobsApi.md#retrieve_jobs) | **GET** /v1/jobs | Retrieve jobs
*MessagesApi* | [**delete_message**](docs/MessagesApi.md#delete_message) | **DELETE** /v1/messages/{id} | Delete a message
*MessagesApi* | [**delete_messages**](docs/MessagesApi.md#delete_messages) | **DELETE** /v1/messages | Delete messages
*MessagesApi* | [**retrieve_message**](docs/MessagesApi.md#retrieve_message) | **GET** /v1/messages/{id} | Retrieve a message
*MessagesApi* | [**retrieve_message_read_receipts**](docs/MessagesApi.md#retrieve_message_read_receipts) | **GET** /v1/messages/{id}/read-receipts | Retrieve message read receipts
*MessagesApi* | [**retrieve_messages**](docs/MessagesApi.md#retrieve_messages) | **GET** /v1/messages | Retrieve messages
*RuntimeApi* | [**create_nodejs_runtime_function**](docs/RuntimeApi.md#create_nodejs_runtime_function) | **POST** /v1/runtimes/nodejs/functions | Create a NodeJS chat runtime function
*RuntimeApi* | [**retrieve_nodejs_runtime**](docs/RuntimeApi.md#retrieve_nodejs_runtime) | **GET** /v1/runtimes/nodejs | Retrieve NodeJS chat runtime
*RuntimeApi* | [**retrieve_nodejs_runtime_functions**](docs/RuntimeApi.md#retrieve_nodejs_runtime_functions) | **GET** /v1/runtimes/nodejs/functions | Retrieve NodeJS chat runtime functions
*RuntimeApi* | [**update_nodejs_runtime_dependencies**](docs/RuntimeApi.md#update_nodejs_runtime_dependencies) | **PUT** /v1/runtimes/nodejs/dependencies | Update NodeJS chat runtime NPM dependencies
*RuntimeApi* | [**update_nodejs_runtime_environment_variables**](docs/RuntimeApi.md#update_nodejs_runtime_environment_variables) | **PUT** /v1/runtimes/nodejs/environment-variables | Update NodeJS chat runtime environment variables
*RuntimeApi* | [**update_nodejs_runtime_initialization_script**](docs/RuntimeApi.md#update_nodejs_runtime_initialization_script) | **PUT** /v1/runtimes/nodejs/initialization-script | Update NodeJS chat runtime initialization script
*ThreadsApi* | [**retrieve_thread**](docs/ThreadsApi.md#retrieve_thread) | **GET** /v1/threads/{id} | Retrieve a thread
*ThreadsApi* | [**retrieve_thread_messages**](docs/ThreadsApi.md#retrieve_thread_messages) | **GET** /v1/threads/{id}/messages | Retrieve reply thread messages
*ThreadsApi* | [**send_thread_message**](docs/ThreadsApi.md#send_thread_message) | **POST** /v1/threads/{id}/messages | Send a reply thread message
*UsersApi* | [**check_user_exists**](docs/UsersApi.md#check_user_exists) | **HEAD** /v1/users | Check a user exists
*UsersApi* | [**create_user**](docs/UsersApi.md#create_user) | **POST** /v1/users | Create a user
*UsersApi* | [**delete_user**](docs/UsersApi.md#delete_user) | **DELETE** /v1/users/{id} | Delete a user
*UsersApi* | [**remove_user_secret**](docs/UsersApi.md#remove_user_secret) | **DELETE** /v1/users/{id}/secrets/{name} | Remove a user secret
*UsersApi* | [**retrieve_user**](docs/UsersApi.md#retrieve_user) | **GET** /v1/users/{id} | Retrieve a user
*UsersApi* | [**retrieve_user_channels**](docs/UsersApi.md#retrieve_user_channels) | **GET** /v1/users/{id}/channels | Retrieve a user&#39;s channels
*UsersApi* | [**retrieve_user_messages**](docs/UsersApi.md#retrieve_user_messages) | **GET** /v1/users/{id}/messages | Retrieve a user&#39;s messages
*UsersApi* | [**retrieve_user_notifications**](docs/UsersApi.md#retrieve_user_notifications) | **GET** /v1/users/{id}/notifications | Retrieve a user&#39;s notifications
*UsersApi* | [**retrieve_user_secret**](docs/UsersApi.md#retrieve_user_secret) | **GET** /v1/users/{id}/secrets/{name} | Retrieve a user secret
*UsersApi* | [**retrieve_users**](docs/UsersApi.md#retrieve_users) | **GET** /v1/users | Retrieve users
*UsersApi* | [**set_user_secret**](docs/UsersApi.md#set_user_secret) | **PUT** /v1/users/{id}/secrets/{name} | Set a user secret
*UsersApi* | [**update_user**](docs/UsersApi.md#update_user) | **PATCH** /v1/users/{id} | Update a user
*UsersApi* | [**update_user_display_picture**](docs/UsersApi.md#update_user_display_picture) | **POST** /v1/users/{id}/display-picture | Update a user&#39;s display picture


## Documentation For Models

 - [AddChannelMemberRequest](docs/AddChannelMemberRequest.md)
 - [ApiError](docs/ApiError.md)
 - [ApplicationJobResource](docs/ApplicationJobResource.md)
 - [ApplicationResource](docs/ApplicationResource.md)
 - [ApplicationSentSystemMessageNotificationData](docs/ApplicationSentSystemMessageNotificationData.md)
 - [ApplicationSettingsProperties](docs/ApplicationSettingsProperties.md)
 - [ApplicationSettingsResource](docs/ApplicationSettingsResource.md)
 - [AuthenticationError](docs/AuthenticationError.md)
 - [ChannelGenericEventResource](docs/ChannelGenericEventResource.md)
 - [ChannelImport](docs/ChannelImport.md)
 - [ChannelInviteResource](docs/ChannelInviteResource.md)
 - [ChannelMembershipImport](docs/ChannelMembershipImport.md)
 - [ChannelMembershipResource](docs/ChannelMembershipResource.md)
 - [ChannelMessageMentionProperties](docs/ChannelMessageMentionProperties.md)
 - [ChannelMessageMentionPropertiesAllOf](docs/ChannelMessageMentionPropertiesAllOf.md)
 - [ChannelProperties](docs/ChannelProperties.md)
 - [ChannelPropertiesPatch](docs/ChannelPropertiesPatch.md)
 - [ChannelResource](docs/ChannelResource.md)
 - [ChatFunctionChatRuntimeProperties](docs/ChatFunctionChatRuntimeProperties.md)
 - [ChatFunctionInvocationResource](docs/ChatFunctionInvocationResource.md)
 - [ChatFunctionResource](docs/ChatFunctionResource.md)
 - [ChatFunctionVersionResource](docs/ChatFunctionVersionResource.md)
 - [ChatRuntimeDependencyProperties](docs/ChatRuntimeDependencyProperties.md)
 - [ChatRuntimeEnvironmentVariablesProperties](docs/ChatRuntimeEnvironmentVariablesProperties.md)
 - [ChatRuntimeProperties](docs/ChatRuntimeProperties.md)
 - [ChatRuntimeResource](docs/ChatRuntimeResource.md)
 - [ChatRuntimeScriptProperties](docs/ChatRuntimeScriptProperties.md)
 - [ChatUserIdReference](docs/ChatUserIdReference.md)
 - [ChatUserIdReferenceAllOf](docs/ChatUserIdReferenceAllOf.md)
 - [ChatUserImport](docs/ChatUserImport.md)
 - [ChatUserMentionedChannelNotificationData](docs/ChatUserMentionedChannelNotificationData.md)
 - [ChatUserMentionedChatUserNotificationData](docs/ChatUserMentionedChatUserNotificationData.md)
 - [ChatUserMessageMentionProperties](docs/ChatUserMessageMentionProperties.md)
 - [ChatUserMessageMentionPropertiesAllOf](docs/ChatUserMessageMentionPropertiesAllOf.md)
 - [ChatUserMessageResource](docs/ChatUserMessageResource.md)
 - [ChatUserPresenceProperties](docs/ChatUserPresenceProperties.md)
 - [ChatUserPresencePropertiesPatch](docs/ChatUserPresencePropertiesPatch.md)
 - [ChatUserProperties](docs/ChatUserProperties.md)
 - [ChatUserPropertiesPatch](docs/ChatUserPropertiesPatch.md)
 - [ChatUserReference](docs/ChatUserReference.md)
 - [ChatUserRepliedToChatUserMessageNotificationData](docs/ChatUserRepliedToChatUserMessageNotificationData.md)
 - [ChatUserResource](docs/ChatUserResource.md)
 - [ChatUserSentChatUserMessageNotificationData](docs/ChatUserSentChatUserMessageNotificationData.md)
 - [ChatUserUsernameReference](docs/ChatUserUsernameReference.md)
 - [ChatUserUsernameReferenceAllOf](docs/ChatUserUsernameReferenceAllOf.md)
 - [CreateChannelGenericEventResource](docs/CreateChannelGenericEventResource.md)
 - [CreateChannelInviteResource](docs/CreateChannelInviteResource.md)
 - [CreateChannelRequest](docs/CreateChannelRequest.md)
 - [CreateChannelResource](docs/CreateChannelResource.md)
 - [CreateChatFunctionResource](docs/CreateChatFunctionResource.md)
 - [CreateChatFunctionVersionResource](docs/CreateChatFunctionVersionResource.md)
 - [CreateDirectChannelResource](docs/CreateDirectChannelResource.md)
 - [CreateExternalFileProperties](docs/CreateExternalFileProperties.md)
 - [CreateFileMessageResource](docs/CreateFileMessageResource.md)
 - [CreateFileMessageResourceAllOf](docs/CreateFileMessageResourceAllOf.md)
 - [CreateMessageResource](docs/CreateMessageResource.md)
 - [CreatePersonChatUserResource](docs/CreatePersonChatUserResource.md)
 - [CreatePrivateChannelResource](docs/CreatePrivateChannelResource.md)
 - [CreatePublicChannelResource](docs/CreatePublicChannelResource.md)
 - [CreateTextMessageResource](docs/CreateTextMessageResource.md)
 - [CreateTextMessageResourceAllOf](docs/CreateTextMessageResourceAllOf.md)
 - [CursorPageMetadata](docs/CursorPageMetadata.md)
 - [CursorPagedModelMessageResource](docs/CursorPagedModelMessageResource.md)
 - [CursorPagedModelMessageResourceEmbedded](docs/CursorPagedModelMessageResourceEmbedded.md)
 - [CursorPagedModelNotificationResource](docs/CursorPagedModelNotificationResource.md)
 - [CursorPagedModelNotificationResourceEmbedded](docs/CursorPagedModelNotificationResourceEmbedded.md)
 - [DirectChannelImport](docs/DirectChannelImport.md)
 - [DirectChannelProperties](docs/DirectChannelProperties.md)
 - [DirectChannelResource](docs/DirectChannelResource.md)
 - [EmojiProperties](docs/EmojiProperties.md)
 - [FileChatUserMessageProperties](docs/FileChatUserMessageProperties.md)
 - [FileChatUserMessagePropertiesAllOf](docs/FileChatUserMessagePropertiesAllOf.md)
 - [FileChatUserMessageResource](docs/FileChatUserMessageResource.md)
 - [FileImport](docs/FileImport.md)
 - [FileProperties](docs/FileProperties.md)
 - [FileSystemMessageProperties](docs/FileSystemMessageProperties.md)
 - [FileSystemMessagePropertiesAllOf](docs/FileSystemMessagePropertiesAllOf.md)
 - [FileSystemMessageResource](docs/FileSystemMessageResource.md)
 - [ImportChannelMembersRequest](docs/ImportChannelMembersRequest.md)
 - [ImportChannelsRequest](docs/ImportChannelsRequest.md)
 - [ImportMessagesRequest](docs/ImportMessagesRequest.md)
 - [ImportUsersRequest](docs/ImportUsersRequest.md)
 - [Link](docs/Link.md)
 - [Links](docs/Links.md)
 - [MessageImport](docs/MessageImport.md)
 - [MessageLinkPreviewImageProperties](docs/MessageLinkPreviewImageProperties.md)
 - [MessageLinkPreviewProperties](docs/MessageLinkPreviewProperties.md)
 - [MessageLinkProperties](docs/MessageLinkProperties.md)
 - [MessageMentionChannelProperties](docs/MessageMentionChannelProperties.md)
 - [MessageMentionProperties](docs/MessageMentionProperties.md)
 - [MessageProperties](docs/MessageProperties.md)
 - [MessageReactionsSummaryProperties](docs/MessageReactionsSummaryProperties.md)
 - [MessageReadReceiptResource](docs/MessageReadReceiptResource.md)
 - [MessageResource](docs/MessageResource.md)
 - [NotificationData](docs/NotificationData.md)
 - [NotificationResource](docs/NotificationResource.md)
 - [NotificationResourceChannel](docs/NotificationResourceChannel.md)
 - [PageMetadata](docs/PageMetadata.md)
 - [PagedModelApplicationJobResource](docs/PagedModelApplicationJobResource.md)
 - [PagedModelApplicationJobResourceEmbedded](docs/PagedModelApplicationJobResourceEmbedded.md)
 - [PagedModelChannelInviteResource](docs/PagedModelChannelInviteResource.md)
 - [PagedModelChannelInviteResourceEmbedded](docs/PagedModelChannelInviteResourceEmbedded.md)
 - [PagedModelChannelMembershipResource](docs/PagedModelChannelMembershipResource.md)
 - [PagedModelChannelMembershipResourceEmbedded](docs/PagedModelChannelMembershipResourceEmbedded.md)
 - [PagedModelChannelResource](docs/PagedModelChannelResource.md)
 - [PagedModelChannelResourceEmbedded](docs/PagedModelChannelResourceEmbedded.md)
 - [PagedModelChatFunctionInvocationResource](docs/PagedModelChatFunctionInvocationResource.md)
 - [PagedModelChatFunctionInvocationResourceEmbedded](docs/PagedModelChatFunctionInvocationResourceEmbedded.md)
 - [PagedModelChatFunctionResource](docs/PagedModelChatFunctionResource.md)
 - [PagedModelChatFunctionResourceEmbedded](docs/PagedModelChatFunctionResourceEmbedded.md)
 - [PagedModelChatFunctionVersionResource](docs/PagedModelChatFunctionVersionResource.md)
 - [PagedModelChatFunctionVersionResourceEmbedded](docs/PagedModelChatFunctionVersionResourceEmbedded.md)
 - [PagedModelChatUserResource](docs/PagedModelChatUserResource.md)
 - [PagedModelChatUserResourceEmbedded](docs/PagedModelChatUserResourceEmbedded.md)
 - [PagedModelMessageReadReceiptResource](docs/PagedModelMessageReadReceiptResource.md)
 - [PagedModelMessageReadReceiptResourceEmbedded](docs/PagedModelMessageReadReceiptResourceEmbedded.md)
 - [PrivateChannelImport](docs/PrivateChannelImport.md)
 - [PrivateChannelImportAllOf](docs/PrivateChannelImportAllOf.md)
 - [PrivateChannelProperties](docs/PrivateChannelProperties.md)
 - [PrivateChannelResource](docs/PrivateChannelResource.md)
 - [PublicChannelImport](docs/PublicChannelImport.md)
 - [PublicChannelProperties](docs/PublicChannelProperties.md)
 - [PublicChannelResource](docs/PublicChannelResource.md)
 - [ReplyThreadResource](docs/ReplyThreadResource.md)
 - [SecretResource](docs/SecretResource.md)
 - [SendChannelMessageRequest](docs/SendChannelMessageRequest.md)
 - [SendChannelMessageRequest1](docs/SendChannelMessageRequest1.md)
 - [SystemMessageResource](docs/SystemMessageResource.md)
 - [TextChatUserMessageImport](docs/TextChatUserMessageImport.md)
 - [TextChatUserMessageImportAllOf](docs/TextChatUserMessageImportAllOf.md)
 - [TextChatUserMessageProperties](docs/TextChatUserMessageProperties.md)
 - [TextChatUserMessagePropertiesAllOf](docs/TextChatUserMessagePropertiesAllOf.md)
 - [TextChatUserMessageResource](docs/TextChatUserMessageResource.md)
 - [TextMessageResource](docs/TextMessageResource.md)
 - [TextSystemMessageImport](docs/TextSystemMessageImport.md)
 - [TextSystemMessageProperties](docs/TextSystemMessageProperties.md)
 - [TextSystemMessagePropertiesAllOf](docs/TextSystemMessagePropertiesAllOf.md)
 - [TextSystemMessageResource](docs/TextSystemMessageResource.md)
 - [UpdateUserDisplayPictureRequest](docs/UpdateUserDisplayPictureRequest.md)


## Documentation For Authorization


## application_authorization

- **Type**: OAuth
- **Flow**: application
- **Authorization URL**: 
- **Scopes**: 
 - **create:***: Create application resources
 - **read:***: Read application resources
 - **update:***: Update application resources
 - **delete:***: Delete application resources


## Author




## Notes for Large OpenAPI documents
If the OpenAPI document is large, imports in openapi_client.apis and openapi_client.models may fail with a
RecursionError indicating the maximum recursion limit has been exceeded. In that case, there are a couple of solutions:

Solution 1:
Use specific imports for apis and models like:
- `from openapi_client.api.default_api import DefaultApi`
- `from openapi_client.model.pet import Pet`

Solution 2:
Before importing the package, adjust the maximum recursion limit as shown below:
```
import sys
sys.setrecursionlimit(1500)
import openapi_client
from openapi_client.apis import *
from openapi_client.models import *
```

